################
# Rozdzial 1   #
# Wprowadzenie #
################

# Operacje arytmetyczne
##########################

rm(list=ls())

2+1
2^3
log(base=2,x=16)

help(log, package=base)
help(log)
?log
args(log)

log(16,2)
log(x=16,2)
log(16, base=2)
log(base=2,x=16)

# Wektory

x <- c(2,1,8,16,4)

summary(x)
T <- length(x); T

a <- 2*x-2;    a
b <- x^2;      b
c <- log(x,2); c

x*x
t(x)%*%x

y1 <- x[c(2,3,4)]; y1
y2 <- x[2:4];      y2
y3 <- x[-c(1,5)];  y3

L1 <- x > 3;      L1
L2 <- all(x>3);   L2
L3 <- any(x>3);   L3
N  <- which(x>3); N

names(x) <- c("a","b","c","d","e")
x[c("c","d","e")]

z1  <- rep(x=1,times=5);z1
z2  <- seq(from=2, to=10, by=2); z2
z3  <- 1:5; z3
z4  <- rnorm(5);z4

ls()

# Macierze

A <- matrix((1:9)^2, nrow = 3, ncol=3, byrow=TRUE)
B <- matrix(0, nrow = 3, ncol=3)
C <- diag(1,3)

A
t(A)

MN <- dim(A); MN
M <- nrow(A); M
N <- ncol(A); N

A1 <- A[c(2,3),c(2,3)]
A2 <- A[-2,-2]
A3 <- A[1:2,1:2]

B1 <- cbind(A1,A2); B1
B2 <- rbind(A1,A2); B2

rownames(A) <- c("r1", "r2", "r3")
colnames(A) <- c("c1", "c2", "c3")
A
A[,"c2"]

det(A)
eigen(A)
solve(A)
A %*% solve(A)
A * solve(A)

# Listy

x <- seq(from=0, to = 10, by=0.5)
y <- 2 + 3*x + rnorm(21)
z <- lm(y ~ x)
names(z)

lista <- list(dane = rnorm(5), rozklad="normalny", par = list(mean=0, sd=1))
lista
names(lista)
summary(lista)

lista[[1]]
lista[["dane"]]
lista$dane

lista[[3]][[2]]
lista[["par"]][["sd"]]
lista$par$sd

# klasy obiektow
######################

x <- c(2,1,8,16,4)
class(x)
is.numeric(x)
is.character(x)


x.char <- as.character(x)
x.ts   <- as.ts(x)
x.ts   <- ts(x, start=2000, freq=1)
tsp(x.ts)
x.date <- as.Date(x, origin="2000-01-01")

summary(x)
summary(x.char)

# warunkowanie
##########################

c   <- exp(1)
sig <- 1
if(sig==1) { 
 	  u <- log(c) 
    } else { 
        u <- (c^sig-1)/(1-sig) 
    } 
u

# funkcje
######################

util <- function(c,sig=1) {
    if(sig==1) { 
 	       u <- log(c) 
        } else { 
             u <- (c^sig-1)/(1-sig) 
               } 
    return(u)
}

util(exp(1))
util(exp(1),2)

# petle
############

x <- 1
for(i in 2:5){
 	x <- c(x,i)
             }
x

x   <- 2
eps <- 1e-8
while(abs(x^2-x-1) > eps) {
 	x <- x - (x^2-x-1)/(2*x - 1)
                          }
x

